Public Member Functions | Static Public Member Functions | Data Fields

# AIConfigWindow Struct Reference

Window to configure which AIs will start. More...

Inheritance diagram for AIConfigWindow:

## Public Member Functions
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
## Static Public Member Functions
static bool | IsEditable (CompanyID slot)
| Can the AI config in the given company slot be edited?
## Data Fields
CompanyID | selected_slot
| The currently selected AI slot or `INVALID_COMPANY`.
int | line_height
| Height of a single AI-name line.
Scrollbar * | vscroll
| Cache of the vertical scrollbar.

## Detailed Description

Window to configure which AIs will start.

Definition at line 729 of file ai_gui.cpp.

## Member Function Documentation

virtual void AIConfigWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 808 of file ai_gui.cpp.

References DrawString(), AIConfig::GetConfig(), GameConfig::GetConfig(), Scrollbar::GetPosition(), IsEditable(), Company::IsValidHumanID(), Scrollbar::IsVisible(), line_height, OWNER_DEITY, SetDParamStr(), vscroll, WD_MATRIX_TOP, WID_AIC_GAMELIST, and WID_AIC_LIST.

static bool AIConfigWindow::IsEditable | ( | CompanyID | slot | ) | `[inline, static]`

Can the AI config in the given company slot be edited?

Parameters:

  | slot | The slot to query.

Returns:
  True if and only if the given AI Config slot can e edited.

Definition at line 792 of file ai_gui.cpp.

References COMPANY_FIRST, GameSettings::difficulty, GetGameSettings(), Company::IsValidHumanID(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), MAX_COMPANIES, DifficultySettings::max_no_competitors, and OWNER_DEITY.

Referenced by DrawWidget(), OnClick(), and OnInvalidateData().

virtual void AIConfigWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 847 of file ai_gui.cpp.

References _network_available, _network_content_client, CONTENT_TYPE_AI, CONTENT_TYPE_GAME, GetGameSettings(), Scrollbar::GetScrolledRowFromWidget(), INVALID_COMPANY, INVALID_STRING_ID, Window::InvalidateData(), IsEditable(), max(), MAX_COMPANIES, min(), ClientNetworkContentSocketHandler::RequestContentList(), Scrollbar::ScrollTowards(), selected_slot, ShowAIListWindow(), ShowAISettingsWindow(), ShowErrorMessage(), ShowNetworkContentListWindow(), ShowScriptTextfileWindow(), Swap(), vscroll, WID_AIC_CHANGE, WID_AIC_CLOSE, WID_AIC_CONFIGURE, WID_AIC_CONTENT_DOWNLOAD, WID_AIC_DECREASE, WID_AIC_GAMELIST, WID_AIC_INCREASE, WID_AIC_LIST, WID_AIC_MOVE_DOWN, WID_AIC_MOVE_UP, WID_AIC_TEXTFILE, and WL_ERROR.

virtual void AIConfigWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 932 of file ai_gui.cpp.

References GetGameSettings(), GetTextfile(), INVALID_COMPANY, IsEditable(), MAX_COMPANIES, OWNER_DEITY, selected_slot, Window::SetWidgetDisabledState(), WID_AIC_CHANGE, WID_AIC_CONFIGURE, WID_AIC_DECREASE, WID_AIC_INCREASE, WID_AIC_MOVE_DOWN, WID_AIC_MOVE_UP, and WID_AIC_TEXTFILE.

virtual void AIConfigWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 752 of file ai_gui.cpp.

References GetGameSettings(), INVALID_COMPANY, OWNER_DEITY, selected_slot, SetDParam(), WID_AIC_CHANGE, and WID_AIC_NUMBER.

virtual void AIConfigWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 776 of file ai_gui.cpp.

References FONT_HEIGHT_NORMAL, GB(), line_height, MAT_ROW_BITS, MAT_ROW_START, WD_MATRIX_TOP, WID_AIC_GAMELIST, and WID_AIC_LIST.

The documentation for this struct was generated from the following file:

- src/ai/ai_gui.cpp